Index: trunk/modules/vci_io_bridge/caba/source/src/vci_io_bridge.cpp
===================================================================
--- trunk/modules/vci_io_bridge/caba/source/src/vci_io_bridge.cpp	(revision 405)
+++ trunk/modules/vci_io_bridge/caba/source/src/vci_io_bridge.cpp	(revision 434)
@@ -1,5 +1,6 @@
-/* i*- c++ -*-C
+/* -*- c++ -*-
  * File : vci_io_bridge.cpp
  * Copyright (c) UPMC, Lip6, SoC
+ * Authors: Cassio Fraga, Alain Greiner
  *
  * SOCLIB_LGPL_HEADER_BEGIN
@@ -29,21 +30,18 @@
 #include "../include/vci_io_bridge.h"
 
+
 //////   debug services   ///////////////////////////////////////////////////////
 // All debug messages are conditionned by two variables:
 // - compile time : DEBUG_*** : defined below
 // - execution time : m_debug_***  : defined by constructor arguments
-//    m_debug_* = (m_debug_ok) and (m_cpt_cycle > m_debug_start_cycle)
+//    m_debug_activated = (m_debug_ok) and (m_cpt_cycle > m_debug_start_cycle)
 /////////////////////////////////////////////////////////////////////////////////
 
 #define DEBUG_DMA_CMD	    	1
 #define DEBUG_DMA_RSP	    	1
-#define DEBUG_DMA_TLB	    	1
+#define DEBUG_TLB_MISS	    	1
 #define DEBUG_CONFIG_CMD		1
 #define DEBUG_CONFIG_RSP		1
-#define DEBUG_MISS_INIT 		1
-
-#define NEW_XRAM_VCI            0
-    
-#define IOMMU_ID		4097
+#define DEBUG_MISS_WTI  		1
 
 namespace soclib { 
@@ -52,156 +50,99 @@
 namespace {
 
-//DMA 
-const char *dma_cmd_fsm_state_str[] = {
+const char *dma_cmd_fsm_state_str[] = 
+    {
         "DMA_CMD_IDLE",
-        "DMA_CMD_TRT_LOCK",
-        "DMA_CMD_TRT_WAIT",
-        "DMA_CMD_TRT_SET",
-        "DMA_CMD_FIFO_PUT",
-        "DMA_CMD_FIFO_MISS_PUT",
-        "DMA_CMD_TLB_MISS_WAIT",
-        "DMA_CMD_TLB_MISS_STORE",
-        "DMA_CMD_ERROR",
+        "DMA_CMD_FIFO_PUT_CMD",
+        "DMA_CMD_FIFO_PUT_RSP",
+        "DMA_CMD_MISS_WAIT",
+        "DMA_CMD_WAIT_EOP",
     };
 
-const char *dma_rsp_fsm_state_str[] = {
+const char *dma_rsp_fsm_state_str[] = 
+    {
         "DMA_RSP_IDLE",
-        "DMA_RSP_TRT_LOCK",
         "DMA_RSP_FIFO_PUT",
-        "DMA_RSP_FIFO_ERROR_PUT",
- };
-
-const char *alloc_trt_dma_fsm_state_str[] = {
-        "ALLOC_TRT_DMA_CMD",
-        "ALLOC_TRT_DMA_RSP",
     };
 
-const char *dma_tlb_fsm_state_str[] = {
-        "DMA_TLB_IDLE",
-        "DMA_TLB_MISS",
-        "DMA_TLB_PTE1_GET",
-        "DMA_TLB_PTE1_SELECT",
-        "DMA_TLB_PTE1_UPDT",
-        "DMA_TLB_PTE2_GET",                                                  
-        "DMA_TLB_PTE2_SELECT",
-        "DMA_TLB_PTE2_UPDT",
-        "DMA_TLB_WAIT_TRANSACTION",
-        "DMA_TLB_RETURN",
-        "DMA_TLB_INVAL_CHECK",
-        "DMA_TLB_INVAL_SCAN",
+const char *tlb_fsm_state_str[] = 
+    {
+        "TLB_IDLE",
+        "TLB_MISS",
+        "TLB_PTE1_GET",
+        "TLB_PTE1_SELECT",
+        "TLB_PTE1_UPDT",
+        "TLB_PTE2_GET",                                                  
+        "TLB_PTE2_SELECT",
+        "TLB_PTE2_UPDT",
+        "TLB_WAIT",
+        "TLB_RETURN",
+        "TLB_INVAL_CHECK",
     };
 
-//CONFIG 
-const char *config_cmd_fsm_state_str[] = {
+const char *config_cmd_fsm_state_str[] = 
+    {
         "CONFIG_CMD_IDLE",
-        "CONFIG_CMD_TRT_LOCK",
-        "CONFIG_CMD_TRT_WAIT",
-        "CONFIG_CMD_TRT_SET",
-        "CONFIG_CMD_FIFO_PUT",
-         
-        // IOB private configuration segment 
-        "CONFIG_CMD_PTPR_WRITE",
-        "CONFIG_CMD_PTPR_READ",
-        "CONFIG_CMD_ACTIVE_WRITE",
-        "CONFIG_CMD_ACTIVE_READ",
-        "CONFIG_CMD_BVAR_READ",
-        "CONFIG_CMD_ETR_READ",
-        "CONFIG_CMD_BAD_ID_READ",
-        "CONFIG_CMD_INVAL_REQ",
-        "CONFIG_CMD_INVAL",
-        "CONFIG_CMD_IT_ADDR_IOMMU_WRITE_1",
-        "CONFIG_CMD_IT_ADDR_IOMMU_WRITE_2",
-        "CONFIG_CMD_IT_ADDR_IOMMU_READ_1",
-        "CONFIG_CMD_IT_ADDR_IOMMU_READ_2",
-        "CONFIG_CMD_IT_ADDR_WRITE_1",
-        "CONFIG_CMD_IT_ADDR_WRITE_2",
-        "CONFIG_CMD_IT_ADDR_READ_1",
-        "CONFIG_CMD_IT_ADDR_READ_2",
-        "CONFIG_CMD_ERROR_WAIT",
-        "CONFIG_CMD_ERROR_RSP",
+        "CONFIG_CMD_FIFO_PUT_CMD",
+        "CONFIG_CMD_FIFO_PUT_RSP",
     };
 
-const char *config_rsp_fsm_state_str[] = {
+const char *config_rsp_fsm_state_str[] = 
+    {
         "CONFIG_RSP_IDLE",
-        "CONFIG_RSP_TRT_LOCK",
         "CONFIG_RSP_FIFO_PUT", 
     };
 
-const char *alloc_trt_config_fsm_state_str[] = {
-        "ALLOC_TRT_CONFIG_CMD",
-        "ALLOC_TRT_CONFIG_RSP",
-    };
-
-//MISS TRANSACTIONS (to Direct Network) 
-const char *miss_init_fsm_state_str[] = {  
-        "MISS_INIT_IDLE_MISS",
-        "MISS_INIT_IDLE_IRQ",
-        "MISS_INIT_IRQ_CMD",
-        "MISS_INIT_IRQ_RSP",
-        "MISS_INIT_TLB_MISS_CMD",
-        "MISS_INIT_TLB_MISS_RSP",
+const char *miss_wti_fsm_state_str[] = {  
+        "MISS_WTI_IDLE_MISS",
+        "MISS_WTI_IDLE_WTI",
+        "MISS_WTI_CMD_WTI",
+        "MISS_WTI_RSP_WTI",
+        "MISS_WTI_CMD_MISS",
+        "MISS_WTI_RSP_MISS",
     };
 }
 
-#define tmpl(...)  template<typename vci_param_d,typename vci_param_x, typename vci_param_io> __VA_ARGS__ VciIoBridge<vci_param_d,vci_param_x,vci_param_io>
-
-/////////////////////////////////
+#define tmpl(...)  template<typename vci_param_int,typename vci_param_ext> __VA_ARGS__ VciIoBridge<vci_param_int,vci_param_ext>
+
+////////////////////////
 tmpl(/**/)::VciIoBridge(
     sc_module_name 			            name,
-    size_t                              nb_periph,
-    const soclib::common::MappingTable 	&mtx,
-    const soclib::common::MappingTable 	&mtd,
-    const soclib::common::MappingTable 	&mtio,
-    const soclib::common::Segment       &seg_config_iob,
-    const soclib::common::IntTab 	    &tgt_index_iocluster,
-//    const soclib::common::IntTab 	    &tgt_index_config,
-    const soclib::common::IntTab 	    &init_index_direct,
-    const soclib::common::IntTab 	    &tgt_index_iospace,
-    const soclib::common::IntTab 	    &init_index_iospace,
-    const soclib::common::IntTab 	    &init_index_dma,
-    size_t                              dcache_words,
-    size_t 				                iotlb_ways,
-    size_t 				                iotlb_sets,
-    uint32_t				            debug_start_cycle,
-    bool				                debug_ok)
+    const soclib::common::MappingTable 	&mt_ext,
+    const soclib::common::MappingTable 	&mt_int,
+    const soclib::common::MappingTable 	&mt_iox,
+    const soclib::common::IntTab 	    &int_tgtid,     // INT network TGTID
+    const soclib::common::IntTab 	    &int_srcid,     // INT network SRCID
+    const soclib::common::IntTab 	    &iox_tgtid,     // IOX network TGTID
+    const bool                          has_irqs,
+    const size_t                        dcache_words,
+    const size_t 				        iotlb_ways,
+    const size_t 				        iotlb_sets,
+    const uint32_t				        debug_start_cycle,
+    const bool				            debug_ok)
     : soclib::caba::BaseModule(name),
 
-      p_clk("clk"),
-      p_resetn("resetn"),
-      p_irq_in(soclib::common::alloc_elems<sc_core::sc_in<bool> >("irq_in", nb_periph)),
-      p_vci_ini_dma("vci_ini_dma"),
-      p_vci_tgt_dma("vci_tgt_dma"),
-      p_vci_ini_config("vci_ini_config"),
-      p_vci_tgt_config("vci_tgt_config"),
-      p_vci_ini_miss("vci_ini_miss"),
-
-      m_words(dcache_words),
-      m_nb_periph(nb_periph),
-      
-      // m_locality_table_config(mtd.getLocalityTable<unsigned long>(tgt_index_iocluster)),
-      // These structures simulate what in hardware will be a correspondence table
-      // Between segments' base address on the direct space and on the IO space
-      // m_routing_table_config(mtd.getRoutingTable<unsigned long>(tgt_index_iocluster)), 
-      //m_mtio(mtio),
-      
-      m_transaction_tab_dma(2),
-      m_transaction_tab_config(1),
-      //Direct Network
-//      m_segment_config(mtd.getSegment(tgt_index_config)),
-      m_segment_config(seg_config_iob),
-      m_srcid_miss(mtx.indexForId(init_index_direct)), 
-      //XRAM Network
-      m_srcid_dma(mtx.indexForId(init_index_dma)),
-      //IO Network
-      m_segment_io(mtio.getSegment(tgt_index_iospace)),
-      m_srcid_config(mtio.indexForId(init_index_iospace)),
+      p_clk("p_clk"),
+      p_resetn("p_resetn"),
+      p_vci_ini_ram("p_vci_ini_ram"),
+      p_vci_tgt_iox("p_vci_tgt_iox"),
+      p_vci_ini_iox("p_vci_ini_iox"),
+      p_vci_tgt_int("p_vci_tgt_int"),
+      p_vci_ini_int("p_vci_ini_int"),
+
+      m_words( dcache_words ),
+      m_has_irqs( has_irqs ),
+
+      // INT & IOX Network
+      m_int_seglist( mt_int.getSegmentList( int_tgtid )),
+      m_int_srcid( mt_int.indexForId( int_srcid )), 
+      m_iox_seglist( mt_iox.getSegmentList( iox_tgtid )),
 
       m_iotlb_ways(iotlb_ways),
       m_iotlb_sets(iotlb_sets),
-      m_paddr_nbits(vci_param_d::N),
 
       m_debug_start_cycle(debug_start_cycle),
       m_debug_ok(debug_ok),
 
+      // addressable registers
       r_iommu_ptpr("r_iommu_ptpr"),
       r_iommu_active("r_iommu_active"),
@@ -209,170 +150,161 @@
       r_iommu_etr("r_iommu_etr"),
       r_iommu_bad_id("r_iommu_bad_id"),
-      r_it_addr_iommu("r_it_addr_iommu"),
-
-      // DMA_CMD 
+      r_iommu_wti_paddr("r_iommu_wti_paddr"),
+      r_iommu_peri_wti(alloc_elems<sc_signal<vci_addr_t> >("r_peri_wti_paddr", 32)),
+
+      // DMA_CMD FSM registers
       r_dma_cmd_fsm("r_dma_cmd_fsm"),
-      r_dma_cmd_fsm_save("r_dma_cmd_fsm_save"),      
-      r_miss_interrupt("r_miss_interrupt"),
-      r_dma_cmd_count("r_dma_cmd_count"),
-      r_dma_cmd_trt_index("r_dma_cmd_trt_index"),
-      r_dma_paddr("r_dma_paddr"),
-      // FIFOs
-      m_dma_cmd_addr_fifo("m_dma_cmd_addr_fifo",4),
-      //m_dma_cmd_length_fifo("m_dma_cmd_length_fifo",4),
-      m_dma_cmd_srcid_fifo("m_dma_cmd_srcid_fifo",4), 
-      m_dma_cmd_trdid_fifo("m_dma_cmd_trdid_fifo",4), 
-      m_dma_cmd_pktid_fifo("m_dma_cmd_pktid_fifo",4), 
-      m_dma_cmd_be_fifo("m_dma_cmd_be_fifo",4), 
-      m_dma_cmd_cmd_fifo("m_dma_cmd_cmd_fifo",4), 
-      m_dma_cmd_contig_fifo("m_dma_cmd_contig_fifo",4), 
-      m_dma_cmd_data_fifo("m_dma_cmd_data_fifo",4), 
-      m_dma_cmd_eop_fifo("m_dma_cmd_eop_fifo",4),
-      m_dma_cmd_cons_fifo("m_dma_cmd_cons_fifo",4), 
-      m_dma_cmd_plen_fifo("m_dma_cmd_plen_fifo",4), 
-      m_dma_cmd_wrap_fifo("m_dma_cmd_wrap_fifo",4), 
-      m_dma_cmd_cfixed_fifo("m_dma_cmd_cfixed_fifo",4),
-      m_dma_cmd_clen_fifo("m_dma_cmd_clen_fifo",4), 
-
-      r_miss_paddr       ("r_miss_paddr"), 
-      r_miss_cmd         ("r_miss_cmd"), 
-      r_miss_contig      ("r_miss_contig"),
-      r_miss_cons        ("r_miss_cons"),
-      r_miss_plen        ("r_miss_plen"),
-      r_miss_wrap        ("r_miss_wrap"),
-      r_miss_cfixed      ("r_miss_cfixed"),    
-      r_miss_clen        ("r_miss_clen"),
-      r_miss_srcid       ("r_miss_srcid"),
-      r_miss_trdid       ("r_miss_trdid"),
-      r_miss_pktid       ("r_miss_pktid"),
-
-      r_dma_error_type("r_dma_error_type"),      
-      r_dma_error_trdid("r_dma_error_trdid"), 
-      r_dma_error_pktid("r_dma_error_pktid"), 
-
- 
-      r_dma_tlb_fsm("r_dma_tlb_fsm"),
+      r_dma_cmd_vaddr("r_dma_cmd_vaddr"),
+      r_dma_cmd_paddr("r_dma_cmd_paddr"),
+
+      //DMA_RSP FSM registers
+      r_dma_rsp_fsm("r_dma_rsp_fsm"),
+
+      // CONFIG_CMD FSM registers 
+      r_config_cmd_fsm("r_config_cmd_fsm"),
+      r_config_cmd_rdata("r_config_cmd_rdata"),
+      r_config_cmd_error("r_config_cmd_error"),
+      r_config_cmd_inval_vaddr("r_config_cmd_inval_vaddr"),
+
+      // CONFIG_RSP FSM registers  
+      r_config_rsp_fsm("r_config_rsp_fsm"),
+
+      // TLB FSM registers
+      r_tlb_fsm("r_tlb_fsm"),
       r_waiting_transaction("r_waiting_transaction"),
       r_tlb_miss_type("r_tlb_miss_type"),
-
-                     
-      r_iotlb_vaddr("r_iotlb_vaddr"),		 // virtual address for a tlb miss
-      r_iotlb_paddr("r_iotlb_paddr"),		 // physical address of pte
-      r_iotlb_pte_flags("r_iotlb_pte_flags"),// pte1 or first word of pte2
-      r_iotlb_pte_ppn("r_iotlb_pte_ppn"),	 // second word of pte2
-      r_iotlb_way("r_iotlb_way"),		     // selected way in tlb    
-      r_iotlb_set("r_iotlb_set"),		     // selected set in tlb    
-
-      r_iotlb("iotlb", IOMMU_ID, iotlb_ways,iotlb_sets,vci_param_d::N),
+      r_tlb_miss_error("r_tlb_miss_error"),
+      r_tlb_paddr("r_tlb_paddr"),		 
+      r_tlb_pte_flags("r_tlb_pte_flags"),
+      r_tlb_pte_ppn("r_tlb_pte_ppn"),
+      r_tlb_way("r_tlb_way"),
+      r_tlb_set("r_tlb_set"),    
+      r_tlb_buf_valid("r_tlb_buf_valid"),
+      r_tlb_buf_tag("r_tlb_buf_tag"),
+      r_tlb_buf_vaddr("r_tlb_buf_vaddr"),
+      r_tlb_buf_big_page("r_tlb_buf_big_page"),
+
+      // MISS_WTI_CMD FSM registers
+      r_miss_wti_cmd_fsm("r_miss_wti_cmd_fsm"), 
+      r_miss_wti_cmd_index("r_miss_wti_cmd_index"),
+
+      // MISS_WTI_CMD FSM registers
+      r_miss_wti_rsp_fsm("r_miss_wti_rsp_fsm"), 
+      r_miss_wti_rsp_error("r_miss_wti_rsp_error"),
+
+      // allocator for CONFIG_RSP & DMA_RSP fifos
+      r_alloc_fifo_config_rsp_local("r_alloc_fifo_config_rsp_local"), 
+      r_alloc_fifo_dma_rsp_local("r_alloc_fifo_dma_rsp_local"), 
+
+      // IRQs registers
+      r_irq_pending(alloc_elems<sc_signal<bool> >("r_irq_pending", 32)),
+      r_irq_request(alloc_elems<sc_signal<bool> >("r_irq_request", 32)),
       
-      //DMA_RSP
-      r_dma_rsp_fsm("r_dma_rsp_fsm"),
-      r_dma_rtrdid("r_dma_rtrdid"),
-      r_dma_rsrcid("r_dma_rsrcid"),
-      //Fifo's
-      m_dma_rsp_data_fifo("m_dma_rsp_data_fifo",4),
-      m_dma_rsp_rsrcid_fifo("m_dma_rsp_rsrcid_fifo",4),
-      m_dma_rsp_rtrdid_fifo("m_dma_rsp_rtrdid_fifo",4),
-      m_dma_rsp_rpktid_fifo("m_dma_rsp_rpktid_fifo",4),
-      m_dma_rsp_reop_fifo("m_dma_rsp_reop_fifo",4),
-      m_dma_rsp_rerror_fifo("m_dma_rsp_rerror_fifo",4),
+      // TLB for IOMMU
+      r_iotlb("iotlb", 0, iotlb_ways, iotlb_sets, vci_param_int::N),
+     
+      // Inter-FSM communications
+      r_dma_tlb_req("r_dma_tlb_req"),
+      r_config_tlb_req("r_config_tlb_req"),
+      r_tlb_miss_req("r_tlb_miss_req"),
       
-      r_dma_cmd_rsp_erase_req("r_dma_cmd_rsp_erase_req"),
-      r_dma_cmd_error_req("r_dma_cmd_error_req"),
-      r_dma_tlb_req("r_dma_tlb_req"),
-      r_tlb_dma_untreated("r_tlb_dma_untreated"), 
-      r_dma_tlb_error_req("r_dma_tlb_error_req"),
-      r_config_tlb_req("r_config_tlb_req"),
-      r_config_tlb_inval_vaddr("r_config_tlb_inval_vaddr"), 
-      
-      // ALLOC TRT DMA
-      r_alloc_trt_dma_fsm("r_alloc_trt_dma_fsm"),
-      
-      // CONFIG CMD
-      r_config_cmd_fsm("r_config_cmd_fsm"),
-      r_config_cmd_trt_index("r_config_cmd_trt_index"),
-     
-      m_config_cmd_addr_fifo("m_config_cmd_addr_fifo",4),
-      //m_config_cmd_length_fifo("m_config_cmd_length_fifo",4),
-      m_config_cmd_srcid_fifo("m_config_cmd_srcid_fifo",4),
-      m_config_cmd_trdid_fifo("m_config_cmd_trdid_fifo",4),
-      m_config_cmd_pktid_fifo("m_config_cmd_pktid_fifo",4),
-      m_config_cmd_be_fifo("m_config_cmd_be_fifo",4),
-      m_config_cmd_cmd_fifo("m_config_cmd_cmd_fifo",4),
-      m_config_cmd_contig_fifo("m_config_cmd_contig_fifo",4),
-      m_config_cmd_data_fifo("m_config_cmd_data_fifo",4),
-      m_config_cmd_eop_fifo("m_config_cmd_eop_fifo",4),
-      m_config_cmd_cons_fifo("m_config_cmd_cons_fifo",4),
-      m_config_cmd_plen_fifo("m_config_cmd_plen_fifo",4),
-      m_config_cmd_wrap_fifo("m_config_cmd_wrap_fifo",4),
-      m_config_cmd_cfixed_fifo("m_config_cmd_cfixed_fifo",4),
-      m_config_cmd_clen_fifo("m_config_cmd_clen_fifo",4),
-      // Private configuration registers
-      r_config_error_type("r_config_error_type"),
-      r_config_first_word("r_config_first_word"),
-      r_it_index("r_it_index"),
-      //Fifo's
-      m_config_local_data_fifo("m_config_local_data_fifo",4),     
-      m_config_local_rsrcid_fifo("m_config_local_rsrcid_fifo",4),
-      m_config_local_rtrdid_fifo("m_config_local_rtrdid_fifo",4),
-      m_config_local_rpktid_fifo("m_config_local_rpktid_fifo",4),
-      m_config_local_reop_fifo("m_config_local_reop_fifo",4),
-      m_config_local_rerror_fifo("m_config_local_rerror_fifo",4),    
-      r_config_vaddr("r_config_vaddr"),
+      // DMA_CMD FIFOs
+      m_dma_cmd_addr_fifo("m_dma_cmd_addr_fifo",2),
+      m_dma_cmd_srcid_fifo("m_dma_cmd_srcid_fifo",2), 
+      m_dma_cmd_trdid_fifo("m_dma_cmd_trdid_fifo",2), 
+      m_dma_cmd_pktid_fifo("m_dma_cmd_pktid_fifo",2), 
+      m_dma_cmd_be_fifo("m_dma_cmd_be_fifo",2), 
+      m_dma_cmd_cmd_fifo("m_dma_cmd_cmd_fifo",2), 
+      m_dma_cmd_contig_fifo("m_dma_cmd_contig_fifo",2), 
+      m_dma_cmd_data_fifo("m_dma_cmd_data_fifo",2), 
+      m_dma_cmd_eop_fifo("m_dma_cmd_eop_fifo",2),
+      m_dma_cmd_cons_fifo("m_dma_cmd_cons_fifo",2), 
+      m_dma_cmd_plen_fifo("m_dma_cmd_plen_fifo",2), 
+      m_dma_cmd_wrap_fifo("m_dma_cmd_wrap_fifo",2), 
+      m_dma_cmd_cfixed_fifo("m_dma_cmd_cfixed_fifo",2),
+      m_dma_cmd_clen_fifo("m_dma_cmd_clen_fifo",2), 
+
+      // DMA_RSP FIFOs
+      m_dma_rsp_data_fifo("m_dma_rsp_data_fifo",2),
+      m_dma_rsp_rsrcid_fifo("m_dma_rsp_rsrcid_fifo",2),
+      m_dma_rsp_rtrdid_fifo("m_dma_rsp_rtrdid_fifo",2),
+      m_dma_rsp_rpktid_fifo("m_dma_rsp_rpktid_fifo",2),
+      m_dma_rsp_reop_fifo("m_dma_rsp_reop_fifo",2),
+      m_dma_rsp_rerror_fifo("m_dma_rsp_rerror_fifo",2),
+ 
+      // CONFIG_CMD FIFOs
+      m_config_cmd_addr_fifo("m_config_cmd_addr_fifo",2),
+      m_config_cmd_srcid_fifo("m_config_cmd_srcid_fifo",2),
+      m_config_cmd_trdid_fifo("m_config_cmd_trdid_fifo",2),
+      m_config_cmd_pktid_fifo("m_config_cmd_pktid_fifo",2),
+      m_config_cmd_be_fifo("m_config_cmd_be_fifo",2),
+      m_config_cmd_cmd_fifo("m_config_cmd_cmd_fifo",2),
+      m_config_cmd_contig_fifo("m_config_cmd_contig_fifo",2),
+      m_config_cmd_data_fifo("m_config_cmd_data_fifo",2),
+      m_config_cmd_eop_fifo("m_config_cmd_eop_fifo",2),
+      m_config_cmd_cons_fifo("m_config_cmd_cons_fifo",2),
+      m_config_cmd_plen_fifo("m_config_cmd_plen_fifo",2),
+      m_config_cmd_wrap_fifo("m_config_cmd_wrap_fifo",2),
+      m_config_cmd_cfixed_fifo("m_config_cmd_cfixed_fifo",2),
+      m_config_cmd_clen_fifo("m_config_cmd_clen_fifo",2),
+
+      // CONFIG_RSP FIFOs
+      m_config_rsp_data_fifo("m_config_rsp_data_fifo",2),     
+      m_config_rsp_rsrcid_fifo("m_config_rsp_rsrcid_fifo",2),
+      m_config_rsp_rtrdid_fifo("m_config_rsp_rtrdid_fifo",2),
+      m_config_rsp_rpktid_fifo("m_config_rsp_rpktid_fifo",2),
+      m_config_rsp_reop_fifo("m_config_rsp_reop_fifo",2),
+      m_config_rsp_rerror_fifo("m_config_rsp_rerror_fifo",2)
+{
+    std::cout << "  - Building VciIoBridge : " << name << std::endl;
+
+    // checking segments on INT network 
+    assert ( ( not m_int_seglist.empty() ) and
+    "VCI_IO_BRIDGE ERROR : no segment allocated on INT network");
+
+    std::list<soclib::common::Segment>::iterator int_seg;
+    for ( int_seg = m_int_seglist.begin() ; int_seg != m_int_seglist.end() ; int_seg++ )
+    {
+        std::cout << "    => segment " << int_seg->name()
+                  << " / base = " << std::hex << int_seg->baseAddress()
+                  << " / size = " << int_seg->size() << std::endl; 
+    }
+
+    // checking segments on IOX network 
+    assert ( ( not m_iox_seglist.empty() ) and
+    "VCI_IO_BRIDGE ERROR : no segment allocated on IOX network");
+
+    std::list<soclib::common::Segment>::iterator iox_seg;
+    for ( iox_seg = m_iox_seglist.begin() ; iox_seg != m_iox_seglist.end() ; iox_seg++ )
+    {
+        std::cout << "    => segment " << iox_seg->name()
+                  << " / base = " << std::hex << iox_seg->baseAddress()
+                  << " / size = " << iox_seg->size() << std::endl; 
+    }
+
+    assert( (vci_param_int::N == vci_param_ext::N) and 
+    "VCI_IO_BRIDGE ERROR: VCI ADDRESS widths must be equal on the 3 networks");
+
+    assert( (vci_param_int::N <=  64) and
+    "VCI_IO_BRIDGE ERROR: VCI ADDRESS width cannot be bigger than 64 bits");
+
+    assert( ((vci_param_int::B == 4) or (vci_param_int::B == 8)) and
+    "VCI_IO_BRIDGE ERROR: VCI DATA width must be 32 or 64 bits on internal network");    
+
+    assert( ((vci_param_ext::B == 4) or (vci_param_ext::B == 8)) and
+    "VCI_IO_BRIDGE ERROR: VCI DATA width must be 32 or 64 bits on external network");    
+
+    assert( (vci_param_int::S == vci_param_ext::S) and
+            "VCI_IO_BRIDGE ERROR: SRCID widths must be equal on the 3 networks");
+
+    // contruct 32 IRQ ports if required
+    if ( has_irqs )
+    {
+        for ( size_t n=0 ; n<32 ; n++ ) p_irq[n] = new sc_core::sc_in<bool>;
+    }
     
-      // CONFIG RSP  
-      r_config_rsp_fsm("r_config_rsp_fsm"),
-      r_config_rtrdid("r_config_rtrdid"),
-      r_config_rsrcid("r_config_rsrcid"),
-      //Fifo's
-      m_config_rsp_data_fifo("m_config_rsp_data_fifo",4),     
-      m_config_rsp_rsrcid_fifo("m_config_rsp_rsrcid_fifo",4),
-      m_config_rsp_rtrdid_fifo("m_config_rsp_rtrdid_fifo",4),
-      m_config_rsp_rpktid_fifo("m_config_rsp_rpktid_fifo",4),
-      m_config_rsp_reop_fifo("m_config_rsp_reop_fifo",4),
-      m_config_rsp_rerror_fifo("m_config_rsp_rerror_fifo",4),    
-
-      // Communication between CONFIG CMD and CONFIG RSP
-      r_config_cmd_rsp_erase_req("r_config_cmd_rsp_erase_req"),      
-    
-      // ALLOC TRT CONFIG 
-      r_alloc_trt_config_fsm("r_alloc_trt_config_fsm"), 
-      // MISS INIT
-      r_miss_init_fsm("r_miss_init_fsm"), 
-      r_miss_rdata("r_miss_rdata"),
-      r_miss_rpktid("r_miss_rpktid"),
-      r_miss_rtrdid("r_miss_rtrdid"),
-      r_miss_rerror("r_miss_rerror"),
-      r_miss_reop("r_miss_reop"),
-      //r_miss_rsrcid("r_miss_rsrcid"),
-      r_miss_rsp_cpt("r_miss_rsp_cpt"),
-      //IRQ
-      r_irq_pending("r_irq_pending"),
-      r_irq_mask("r_irq_mask"),
-      r_irq_chosen("r_irq_chosen"),
-      
-      r_tlb_miss_init_req("r_tlb_miss_init_req"),
-      r_miss_init_error("r_miss_init_error"),
-      
-      r_miss_buf_valid("r_miss_buf_valid"),
-      r_miss_buf_tag("r_miss_buf_tag")
-{
-    assert( (vci_param_d::N <=  64) and
-            "ADDRESS cannot be bigger than 64 bits");
-    assert( (vci_param_x::B)*8 == 64 and (vci_param_io::B)*8 == 64 and
-            "DATA field must be 64 bits in Extern and IO Network");
-    assert ( (vci_param_d::B)*8 == 32 
-        and "Error: data field in Direct Noc must be 32 bits" );
-                    
-    
-    // Interruption Address vector, one entry for each IO
-    r_it_addr           = new paddr_t[nb_periph];
-    // One cache line buffer
-    r_miss_buf_data     = new vci_data_t[dcache_words];
-    // Command storage in case of miss TLB
-    // (dcache_words/2) => Maximal size of a write command 
-    r_miss_data     = new vci_data_t[dcache_words]; 
-    r_miss_be     = new vci_be_t[dcache_words];
-    
+    // Cache line buffer
+    r_tlb_buf_data = new uint32_t[dcache_words];
+
     SC_METHOD(transition);
     dont_initialize();
@@ -389,9 +321,9 @@
 /////////////////////////////////////
 {
-    delete [] r_it_addr;
-    delete [] r_miss_buf_data;
-    delete [] r_miss_data;
-    delete [] r_miss_be;
-    soclib::common::dealloc_elems(p_irq_in, m_nb_periph);
+    delete [] r_iommu_peri_wti;
+    delete [] r_tlb_buf_data;
+    soclib::common::dealloc_elems(p_irq, 32);
+    soclib::common::dealloc_elems(r_irq_request, 32);
+    soclib::common::dealloc_elems(r_irq_pending, 32);
 }
 
@@ -404,13 +336,11 @@
     std::cout << std::dec << "IO_BRIDGE " << name() << std::endl;
 
-    std::cout << "  " << dma_cmd_fsm_state_str[r_dma_cmd_fsm.read()]
+    std::cout << "  "  << dma_cmd_fsm_state_str[r_dma_cmd_fsm.read()]
               << " | " << dma_rsp_fsm_state_str[r_dma_rsp_fsm.read()]
-              << " | " << dma_tlb_fsm_state_str[r_dma_tlb_fsm.read()]
-              << " | " << alloc_trt_dma_fsm_state_str[r_alloc_trt_dma_fsm.read()]
+              << " | " << tlb_fsm_state_str[r_tlb_fsm.read()]
               << " | " << config_cmd_fsm_state_str[r_config_cmd_fsm.read()]
               << " | " << config_rsp_fsm_state_str[r_config_rsp_fsm.read()]
-              << " | " << alloc_trt_config_fsm_state_str[r_alloc_trt_config_fsm.read()]
-              << " | " << miss_init_fsm_state_str[r_miss_init_fsm.read()];
-    std::cout << std::endl;
+              << " | " << miss_wti_fsm_state_str[r_miss_wti_cmd_fsm.read()]
+              << std::endl;
 
     if(mode & 0x01)
@@ -424,6 +354,4 @@
     }
 }
-
-
 
 ////////////////////////
@@ -447,9 +375,4 @@
     m_cpt_iotlbmiss_transaction     = 0;    
     m_cost_iotlbmiss_transaction    = 0;   
-        
-    m_cpt_trt_dma_full          = 0;
-    m_cpt_trt_dma_full_cost     = 0;
-    m_cpt_trt_config_full          = 0;
-    m_cpt_trt_config_full_cost     = 0;
 }
 
@@ -460,20 +383,18 @@
     if ( not p_resetn.read() ) 
     {
-
-        r_dma_cmd_fsm		    = DMA_CMD_IDLE;
-        r_dma_rsp_fsm		    = DMA_RSP_IDLE;
-        r_alloc_trt_dma_fsm     = ALLOC_TRT_DMA_CMD;
-        r_dma_tlb_fsm	        = DMA_TLB_IDLE;
-        r_config_cmd_fsm	    = CONFIG_CMD_IDLE;
-        r_config_rsp_fsm	    = CONFIG_RSP_IDLE;
-        r_alloc_trt_config_fsm  = ALLOC_TRT_CONFIG_CMD;
-        r_miss_init_fsm		    = MISS_INIT_IDLE_MISS;
-
-        //miss buffer invalidation
-        r_miss_buf_valid = false; 
-        
-		r_iommu_active = false;
-
-        r_dma_cmd_count = 0;
+        r_dma_cmd_fsm	   = DMA_CMD_IDLE;
+        r_dma_rsp_fsm	   = DMA_RSP_IDLE;
+        r_tlb_fsm	       = TLB_IDLE;
+        r_config_cmd_fsm   = CONFIG_CMD_IDLE;
+        r_config_rsp_fsm   = CONFIG_RSP_IDLE;
+        r_miss_wti_cmd_fsm = MISS_WTI_CMD_IDLE;
+        r_miss_wti_rsp_fsm = MISS_WTI_RSP_IDLE;
+
+        r_alloc_fifo_config_rsp_local = true;
+        r_alloc_fifo_dma_rsp_local    = true;
+
+        r_tlb_buf_valid    = false; 
+		r_iommu_active     = false;
+		r_iommu_wti_enable = false;
         
         // initializing FIFOs
